VeCAD - What's new in the latest version

31-Jan-2004 ver.6.0.44
- Added CadEngrave function and "Engrave" event.
- Added events "EntErase" and "EntMove".
- Added missing localization strings.
- Changed dialogs "Insert Image" and "Image Manager".
- Fixed bug: division by zero in "Viewpoint presets" dialog.

22-Jan-2004 ver.6.0.43
- Fixed some bugs of export to DXF/DWG.
- Fixed bug: text in complex point objects has wrong Z coordinate.
- Fixed bug #33: EntSelect Event not called correctly for deselection operations. 
- Fixed bug #34: Can't invoke interactive commands from custom popup menu.

15-Jan-2004 ver.6.0.42
- Fixed bug: CadPageCopy function creates duplicate layers.

14-Jan-2004 ver.6.0.41
- Changed syntax of the "EntSelect" event. Added "bFinal" parameter.

14-Jan-2004 ver.6.0.40
- Added the "View" event which are generated after a drawing's view in a window was changed.
- Fixed bug: global parameters CAD_GL_USEGRIPS and CAD_GL_FILEEXT have not effect.
- Fixed bug: can't copy/paste "Leader" objects via clipboard.

12-Jan-2004 ver.6.0.39
- Added event "EntSelect" which are generated before an entity's selection state will be changed.
- Added event "MouseDblClk" which are generated when user double clicks mouse button in VeCAD window.
- Fixed bug: CadSetString function can't localize popup menus items.
- Fixed bug: wrong alignment of some text entities imported from AutoCAD drawings.

07-Jan-2004 ver.6.0.38
- Fixed bug #19: filled area of circles do not coincide with border
- Fixed bug: crash when use CadPurge function with CAD_CLEAR_DELETED parameter on drawings with blocks insertions.

06-Jan-2004 ver.6.0.37
- Fixed bug: leak of GDI objects in VeCAD OCX
- Fixed bug #21: crash if open dialog "Open File" (new version with preview) under Windows less then XP

06-Jan-2004 ver.6.0.36
- Improved display quality of polygons when viewed at small resolution
- Fixed bug: crash if set Step=0 in the CadGridGetBoldStep function
- Fixed bug: when explode Block Insertion the in-block Face3D entities diappear

04-Jan-2004 ver.6.0.35
- Added global parameter CAD_GL_ENUMDELENTS. 
- Added utility functions CadExtractImage, CadCompress, CadExpand. 
- Added a drawing's preview to the "Open File" and "Recent files list" dialogs. 
- Fixed bug: crash if add Xref object to drawing and save to DWG format.

01-January-2004 ver.6.0.34
- Fixed bug: can't run Vecad by user that have not administration rights.

31-December-2003 ver.6.0.33
- Changed syntax of CadNavCreate function.
- Fixed bug: drawing's view in the Navigator don't updated when current page is changed.
- Fixed bug: Navigator saves wrong position if it was moved.

29-December-2003 ver.6.0.32
- Fixed bug: "Print setup" dialog disappear when click mouse outside of the dialog.
- Fixed bug: crash when open "Dim Styles" dialog for drawings created with ver.6.0.23 and earlier.
- Fixed bug: can't import XREF objects from AutoCAD drawings
- Fixed bug: the button "Back" in the "Viewpoint Presets" dialog don't work
- Added strings STR_NAV_...

24-December-2003 ver.6.0.31
- Added "Navigator" control.
- Added function CadEntityGetSelected to deternine either entity is selected or not.
- Added function CadGetEntitiesByPoint to retrieve multiply entities at given window point.
- Added functions CadGetParam and CadSetParam to access VeCAD global parameters.
- Fixed bugs: import dwg/dxf: text style width; empty blocks make wrong drawing's extents (0,0); frozen layers are visible.
- Fixed bug: CadSelectEntity function don't updates display list when used to unselect entity.
- Fixed bug: crash during draw a ray or infinite line if unite start and endpoint.
- Fixed bug: straight arcs are losted when explode polyline with arc segments.
- Fixed bug: tools with dialogs makes crash after closing the dialog.
- Fixed bug: CadEntityExplode remains 'InBlock' flag for exploded entities of Block Insertion.
- Fixed bug: crashes when move empty text entity, at some cases.
- Fixed bug: can't enter numbers in command line by number keypad

16-December-2003 ver.6.0.30
- Added functions CadGetFirstEntity and CadGetNextEntity to enumerate entities without layers cycle. 
- Added functions CadEntityExplode, CadEntityMoveGrip, CadEntityGetGrip. 
- Added events "Execute", "GripDrag", "GripMove", "CmdStart", "CmdLBDown", "CmdFinish". 

23-November-2003 ver.6.0.29
- Added the "Magnifier" object.
- Added functions for Grid object, to control its color, type and level properties.
- Added functions to load / save color palette.
- Added functions to set current color and linetype. See the "Drawing's properties" topic.

16-November-2003 ver.6.0.28
- Added "Blocks" dialog. It is called by CAD_CMD_BLOCK command. 
- Added "Trim" command. It is called by CAD_CMD_TRIM command and can be applied to line, linear polyline, circle, circular arc. 
- Added "Extend" command. It is called by CAD_CMD_EXTEND command and can be applied to line, non-closed linear polyline, circular arc. 
- Added "Blink" and "Visibile" properties for an entity, and the corresponding functions: CadSetBlinkTime, CadEntityGetBlink, CadEntityPutBlink, CadEntityGetVisible, CadEntityPutVisible. 
- Fixed bug: user can't edit entities with VeCAD OCX. 

30-October-2003 build 27
- Added "Explode" operation for Multiline objects.
- Added types of objects that can be exported to AutoCAD dwg/dxf file: Multilines, Points, filled Circles and Polylines.
- Improved quality of small circe's appearance in a window.
- Fixed bug: problems with export/import AutoCAD dwg/dxf drawings.
- Fixed bug: CadAddImage function can't load ECW image.
- Fixed bug: can't select some edges to define a Hatch boundary.
- Fixed bug: "EntCreate" and "EntChange" events don't work in VeCAD OCX.

24-October-2003 build 26
- Added "CadApi2.bas" file which must be included in Visual Basic projects, along with "CadApi.bas" file.
- Added functions CadEntityGetBordColor, CadEntityPutBordColor, to set border's color for filled entities with border. 
- Added functions CadPageCopy, CadPageSave. 
- Added event "EntCreate" that are generated after a user have created an entity. 
- Changed syntax of the "EntChange" event procedure (added hDwg parameter). 
- Enhanced the "Bezier" fit type of a polyline. Now user can use control points to set the curvature. 
- Fixed bug: Hatch and Dimension entities can't be copied via clipboard. 
- Fixed bug: in some cases can't find hatch boundaries. 
- Fixed bug: crash when export some drawings to dxf/dwg. 

14-October-2003 build 25
- Changed syntax of the CadEntityErase function, added parameter that allows to unerase objects. 
- Added functions CadEntityGetDeleted, CadLayerGetDeleted, to control the "deleted" state of the objects. 
- Added functions CadPrintGetPaperW, CadPrintGetPaperH, CadPrintGetPaperSize to retrieve a printer paper dimensions. 
- Added functions CadSetMinCharFSize, CadGetMinCharFSize to control a filling of text characters. 
- Added function CadViewScale to change visible scale of a drawing in a window. 
- Added functions CadSetViewCoefs and CadGetViewCoefs to control zoom/pan coefficients. 
- Added event "EntChange" that are generated after an entity was modified. 
- Added several new code samples. 
- Fixed bug: "Join" command don't work properly 

08-October-2003 build 24
- Added new object types: Dimension style, Dimension, Leader. 
- Added function CadConvertAcadFile for direct converting AutoCAD file formats. 

25-September-2003 build 23
- Added a group of functions to keep additional text information in a drawing (CadPutDescr and others). 
- Added a group of functions to keep additional text information in a layer (CadLayerPutDescr and others). 
- Added possibility to use empty string for filename in the CadFileSaveAs function. The "Save File" dialog will appear at this case. 
- Changed syntax of the CadPutExData function and the CadPutExDataSize function is deleted. 
- Changed name of OCX method Print to Print2. 
- Fixed bug: OCX method FileSaveAs don't works. 
- Fixed bug: selection by polygon selects invisible objects. 
- Fixed bug: can't import some drawings made by VeCAD 5.2.


22-September-2003 build 22
- ECW plug-in is created.
- OCX interface is updated, now it has the same functionality as the API.
- Added command CAD_CMD_SEL_BYUSERDATA to select object by its "User Data" property. Also added corresponding field to "Properties" window, so you can view and edit this property interactively.
- Added functions CadGetExtentLeft, CadGetExtentBottom, CadGetExtentRight, CadGetExtentTop, CadGetExtentRect to retrieve a drawing's extents at current 2D projection.
- Fixed bug: can't select entities if current page was changed programmatically.
- Fixed bug: selection by polygon sometimes selects small entities outside of the polygon.

10-September-2003 build 21
- Added functions CadAddCircle3P, CadAddArc3P
- Added "Explode" operation for "Point" objects.
- Fixed bug: Arc don't keep a direction when it created by 3 points (always counter-clockwise).
- Fixed bug: Don't import point styles from VeCAD v5.2 drawings.
- Fixed bug: Can't edit angle values for some objects in the "Properties" window.
- Fixed bug: Text alignment don't work at some cases when create a drawing programmatically.
- Fixed bug: FileOpen method in VeCAD OCX don't work if VeCAD object has not a focus.

30-August-2003 build 20
- Added the "Explode" command and CadSelExplode function that decomposes a selected entities to less complex entities.

26-August-2003 build 19
- Added the CadEntityPutLayerID function to move an object from one layer to another.
- Added a group of functions (CadGetWin...) to retrieve a coordinates of a drawing's part that are currently visible in a window.
- Added a possibility to save a drawing as a raster image. See the CadRasterize function and the SaveDib event. 
- Added a group of functions to control Lineweights. Read topic "VeCAD API / Base services / Drawings properties" in the help file.
- Fixed bug: can't create a complex linetype. Changed syntax of a Linetype description. 
- Fixed bug: polyline object are not exported to AutoCAD dwg/dxf format.

20-August-2003 build 18
- Added possibility to use "plugins.txt" file to define plug-in libraries for VeCAD.
- Added event "KeyDown".
- Added CadSelDraw function to draw selected objects on any window.
- Added CadGetWindow function to receive a handle to a window associated with a drawing.
- Added a set of functions to store an application-specific data in VeCAD drawing: CadGetExDataSize, CadPutExDataSize, CadGetExData, CadPutExData.
- Fixed bug: FontName combobox in the "Text Style" dialog has zero height.
- Fixed bug: wrong appearance for some drawings imported from VeCAD 5.2.

03-August-2003 build 17
- Added functions CadEntityGetLeft, CadEntityGetBottom, CadEntityGetRight, CadEntityGetTop to retrieve entity's extents at current 2D display projection.
- Added functions CadEntityNumPaths, CadEntityGetPathSize, CadEntityGetVer to retrieve interpolated polyline of entity's contour at current 2D display projection.
- Fixed bug: Don't filter empty blocks when read dwg/dxf files.

18-July-2003  build 16
- Added functions CadSelectByPolyline, CadSelectByPolygon, CadSelectByDist, that give more flexibility to select entities.

09-July-2003  build 15
- Added functions CadPrintPutOrient and CadPrintGetOrient to control drawing's orientation on a printer paper. 
- Added function CadCboxCreate to create VeCAD interface controls - comboxes "Layer", "Colors", "linetypes", "Lineweights". 

06-July-2003  build 14
- Added "External Reference" object. Read topic "VeCAD API / Entities / External reference" in the help file.
- Added function CadAddHatchPath to define outline for a Hatch object. 
- Added functions CadSetImageBorder and CadGetImageBorder to control visibility of a border around image entities.
- Added functions CadSetAngleUnit and CadGetAngleUnit to control VeCAD angle units. 
- Fixed bug: don't draw border of filled polygon when printed.
- Fixed bug: can't put "Hatch" object into a block.
- Fixed bug: can't hatch filled polygons

02-July-2003  build 13
- Created identifiers for all VeCAD strings. Default texts are listed in the "strings.txt" file.
- Added possibility to customize VeCAD popup menus. Read topic "VeCAD API / Base services / Customize menus" in the help file.
- Added functions CadAddRect and CadAddRectFill to create rectangles in a drawing.
- Fixed bug: can't change angles for Polar Tracking programmatically.
- Fixed bug: Polar Tracking with option "Relative measurement" don't work at some cases.
- Fixed bug: application crashes when use CadPolarAddAngle.

28-June-2003  build 12
- Changed concept of supporting raster images, now possible to use plug-in libraries for different raster formats.
  Read topic "VeCAD API / Using VeCAD API with applications / Plug-ins for raster formats" in the help file.
- Added function CadAddImagePlace to add "drawn-by-client" images to drawing.
- Added events "Paint" and "DrawImage". Read topic "VeCAD API / Events" in the help file.
- Fixed bug: Some tools in a combination with Polar Tracking make "dirt" on a window.
- Fixed bug: CadSetShowSysCursor has not effect

23-June-2003  build 11
- Added "Object Snap" and "Polar Tracking" features. Read topic "VeCAD API/Draw with precision" in the help file.
- Added function CadGetEntityByUserData to locate an entity by its "UserData" property.

12-June-2003  build 10
- Added functions for "Multiline" object. Read topic "VeCAD API/Entities/Multiline" in the help file.
- Added function CadSetString that can be used for VeCAD localization. Read topic "VeCAD API / Using VeCAD API with applications / Localization" in the help file.
- Fixed bug: CadAddPage function ignores predefined paper sizes.
- Fixed bug: MouseMove event don't work in VeCAD OCX

06-June-2003 build 9
- Added functions for command window. Read topic "VeCAD API/Base services/Command window" in the help file. 
- Fixed bug: can't rightly define a boundaries for "Hatch" object in a multipage drawing.
- Fixed bug: crash when Copy/Paste objects between drawings via clipboard.

03-June-2003 build 8
- Added "Hatch" object, for more information read topic "VeCAD API/Graphic Objects/Hatch" in the help file. 
- Added functions CadFileNew, CadSetMiterLimit, CadGetMiterLimit
- Added events "Select Codepage" and "Font Replacement" that allows to hide the corresponding dialogs.
- Fixed bug: CadAddImage function don't add an image.
- Fixed bug: CadFileSave don't saves a drawing with other than VEC extension if its name was changed by CadPutFileName function.

21-May-2003 build 7
- Added "Draw Multiline" command (identifier CAD_CMD_DRAW_MLINE)
- Added CadPrintSetup function
- Added "Printer device context" parameter to the CadPrint function
- Fixed bug: can't open VEC drawings that was saved with version 6.0.5 or 6.0.6

20-May-2003 build 6
- Fixed bug: can't create block by using "Create Block" dialog
- Fixed bug: fails to load drawings that have polylines with non-continuous linetype and duplicate vertices

19-May-2003 build 5
- Changed fonts concepts. Read topic "VeCAD API/Base Services/Fonts" in the help file.

03-May-2003 build 4
- Fixed bug: can't open DXF file produced by AutoCAD with R13 and R14 file type.

30-Apr-2003 build 3
- fixed bug: in-block entities with non-continuous linetype are shifted in
block insertion
- fixed bug: text style and point style don't save font name in drawing
file, therefore text objects are drawn with different fonts when a 
drawing are opened on other computer.
- added page functions

11-Apr-2003 build 2
- Fixed bug: can't load SHP font file that have long font descriptor
- Changed syntax of Mouse events

01-Apr-2003
- fixed bug: can't load SHP font file that have long font descriptor
